import { IMetricClient } from './types/client/IMetricClient';
import { Counter } from './types/metrics/Counter';
import { Gauge } from './types/metrics/Gauge';
import { Histogram } from './types/metrics/Histogram';
import { Timer } from './types/metrics/Timer';
import { Namespace } from './types/Namespace';
export declare const setDefaultClient: (client: IMetricClient) => void;
export declare const setDefaultNamespace: (domain: string, module: string) => void;
export declare const getNamespace: (domain: string, module: string) => Namespace;
export declare const setAttribute: (attributeName: string, attributeValue: string) => void;
export declare const removeAttribute: (attributeName: string) => void;
export declare const createGauge: (metricName: string, description?: string | undefined, unit?: string | undefined, attributes?: Record<string, string>) => Gauge | undefined;
export declare const recordGauge: (metricName: string, value: number, attributes?: Record<string, string>) => void;
export declare const createCounter: (metricName: string, description?: string | undefined, unit?: string | undefined, attributes?: Record<string, string>) => Counter | undefined;
export declare const incrementCounter: (metricName: string, value?: number, attributes?: Record<string, string>) => void;
export declare const createHistogram: (metricName: string, description?: string | undefined, unit?: string | undefined, buckets?: number[], attributes?: Record<string, string>) => Histogram | undefined;
export declare const recordHistogram: (metricName: string, value: number, buckets?: number[], attributes?: Record<string, string>) => void;
export declare const createTimer: (metricName: string, description?: string | undefined, unit?: string | undefined, buckets?: number[], attributes?: Record<string, string>) => Timer | undefined;
export declare const recordTimer: (metricName: string, value: number, buckets?: number[], attributes?: Record<string, string>) => void;
export declare function time<A extends any[], R>(metricName: string, buckets: number[] | undefined, attributes: Record<string, string> | undefined, fn: (...args: A) => R | Promise<R>, ...args1: A): R | Promise<R> | undefined;
export declare function timeAndCount<R>(metricNamePrefix: string, fn: () => R | Promise<R>, buckets?: number[], attributes?: Record<string, string>): R | Promise<R> | undefined;
export declare function metricWrapper<A extends any[], R>(metricNamePrefix: string, buckets: number[] | undefined, attributes: Record<string, string> | undefined, fn: (...args: A) => R | Promise<R>, ...args1: A): R | Promise<R> | undefined;
export declare function timeDecorator<A extends any[]>(metricName: string, buckets?: number[], attributes?: Record<string, string>): (_target: any, _propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
export declare function timeAndCountDecorator<A extends any[]>(metricNamePrefix: string, buckets?: number[], attributes?: Record<string, string>): (_target: any, _propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
export * from './types/client/StatsDClient';
export * from './types/client/InMemoryClient';
