import { IMetricClient } from './client/IMetricClient';
import { Counter } from './metrics/Counter';
import { Gauge } from './metrics/Gauge';
import { Histogram } from './metrics/Histogram';
import { Metric } from './metrics/Metric';
import { Timer } from './metrics/Timer';
export declare class Namespace {
    private readonly EmptyValue;
    private metricClient;
    private domain;
    private module;
    private metrics;
    private attributes;
    constructor(metricClient: IMetricClient, domain?: string, module?: string);
    getMetricClient(): IMetricClient;
    getDomain(): string;
    getModule(): string;
    getNamespacePrefix(): string;
    getAttributes(): Record<string, string>;
    getAttribute(attributeName: string): string | undefined;
    setAttribute(attributeName: string, attributeValue: string): void;
    removeAttribute(attributeName: string): void;
    getMetric(metricName: string): Metric | undefined;
    createGauge(metricName: string, description?: string, unit?: string, attributes?: Record<string, string>): Gauge;
    recordGauge(metricName: string, value: number, attributes: Record<string, string>): void;
    createCounter(metricName: string, description?: string, unit?: string, attributes?: Record<string, string>): Counter;
    incrementCounter(metricName: string, value: number, attributes: Record<string, string>): void;
    createHistogram(metricName: string, description?: string, unit?: string, buckets?: number[], attributes?: Record<string, string>): Histogram;
    recordHistogram(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    createTimer(metricName: string, description?: string, unit?: string, buckets?: number[], attributes?: Record<string, string>): Timer;
    recordTimer(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    time<A extends any[], R>(metricName: string, buckets: number[] | undefined, attributes: Record<string, string> | undefined, fn: (...args: A) => R | Promise<R>, ...args1: A): R | Promise<R>;
    timeAndCount<R>(metricNamePrefix: string, fn: () => R | Promise<R>, buckets?: number[], attributes?: Record<string, string>): R | Promise<R> | undefined;
    metricWrapper<A extends any[], R>(metricNamePrefix: string, buckets: number[] | undefined, attributes: Record<string, string> | undefined, fn: (...args: A) => R | Promise<R>, ...args1: A): R | Promise<R>;
    private isThenable;
    private isEmptyNamespace;
    private getMetricKey;
    private getGauge;
    private getCounter;
    private getHistogram;
    private getTimer;
}
