import { Namespace } from '../Namespace';
export interface IMetricClient {
    setDefaultNamespace(domain: string, module: string): void;
    getDefaultNamespace(): Namespace | undefined;
    getNamespace(domain: string, module: string): Namespace;
    getAttributes(): Record<string, string>;
    setAttribute(attributeName: string, attributeValue: string): void;
    removeAttribute(attributeName: string): void;
    recordGauge(metricName: string, value: number, attributes: Record<string, string>): void;
    incrementCounter(metricName: string, value: number, attributes: Record<string, string>): void;
    recordTimer(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    recordHistogram(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
}
