import { IMetricClient } from './IMetricClient';
import { Namespace } from '../Namespace';
export declare abstract class MetricClient implements IMetricClient {
    private isEnabled;
    private defaultNamespace;
    private namespaces;
    private attributes;
    constructor(isEnabled?: boolean);
    getDefaultNamespace(): Namespace | undefined;
    setDefaultNamespace(domain: string, module: string): void;
    getNamespace(domain: string, module: string): Namespace;
    getAttributes(): Record<string, string>;
    getAttribute(attributeName: string): string | undefined;
    setAttribute(attributeName: string, attributeValue: string): void;
    removeAttribute(attributeName: string): void;
    incrementCounter(metricName: string, value: number, attributes: Record<string, string>): void;
    recordGauge(metricName: string, value: number, attributes: Record<string, string>): void;
    recordTimer(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    recordHistogram(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    protected getNamespaceKey(domain: string, module: string): string;
    private setDefaultHostnameAttribute;
    abstract counterImpl(metricName: string, value: number, attributes: Record<string, string>): void;
    abstract gaugeImpl(metricName: string, value: number, attributes: Record<string, string>): void;
    abstract timeImpl(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
    abstract histogramImpl(metricName: string, value: number, buckets: number[], attributes: Record<string, string>): void;
}
