import { Namespace } from '../Namespace';
export declare abstract class Metric {
    private namespace;
    private name;
    private description;
    private unit;
    private attributes;
    constructor(namespace: Namespace, name: string, description?: string, unit?: string, attributes?: Record<string, string>);
    getNamespace(): Namespace;
    getName(): string;
    getDescription(): string;
    getUnit(): string;
    getAttributes(): Record<string, string>;
    getAttribute(attributeName: string): string | undefined;
    setAttribute(attributeName: string, attributeValue: string): void;
    removeAttribute(attributeName: string): void;
    combineAttributes(attributes: Record<string, string>): Record<string, string>;
    getFullName(): string;
}
